//+---------------------------------------------------------------------+
//|                                           N0_General-Revers_WPR.mq4 |
//|                                     Copyright  2007, Tradersforum. |
//|                                     http://www.tradersforum.net.ru/ | 
//|                                             Leonid553 & NoName(-and)|
//+---------------------------------------------------------------------+

#property copyright "Leonid553&NoName(-and)"
#property link      "http://www.tradersforum.net.ru/"

//---- input parameters

extern string direct= "  ";
extern int  MagicNumber=884;
extern bool General=True;
extern int  WPR_period=6;
extern int  sl = 70;
extern int  x1 = 105;
extern int  x2 = 106; 
extern int  x3 = 81;
extern int  x4 = 105;
extern int  x5 = 94;


extern string revers= "  ";
extern int  MagicRevers=484;
extern bool Revers=false;
extern int  WPR_REV_period=5;
extern int  sl_r = 82;
extern int  r1 = 91; 
extern int  r2 = 52; 
extern int  r3 = 97; 
extern int  r4 = 95;
extern int  r5 = 92;  


extern string general= " ";
//extern int   tp = 72;
//--- ------------
extern int   P_1=0;
extern int   P_2=7; 
extern int   P_3=14; 
extern int   P_4=21;
extern int   p_5=10;

//--   ---------------
#include  <stdlib.mqh>
#include  <b-Lots.mqh>  // 
//#include  <VisualTestingTools.mq4> //
//--------------------------------------
static int prevtime = 0;
static int spread   = 3;
//--
int ExpertBars;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//vTerminalInit();
//----------------
ExpertBars = Bars;
//----------------
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//vTerminalRefresh();
//-------------------------------------------------------
bool isNewBar=false;
if (ExpertBars !=Bars) {ExpertBars=Bars; isNewBar=true; }
//-------------------------------------------------------

if (isNewBar) {  

int spread = MarketInfo(Symbol(), MODE_SPREAD);
//-----------------------------------
double GeneralSignal =perceptron  ();
double ReversSignal  =perceptron_r();
//-----     -----------------------------------------------------
string info="";
string on_off="-------------------------------------------------------------"+ "\r\n";
if (General) on_off=StringConcatenate (on_off,"      - . ", "\r\n");
else         on_off=StringConcatenate (on_off,"      - . ","\r\n");
if (Revers)  on_off=StringConcatenate (on_off,"  - . ",  "\r\n");
else         on_off=StringConcatenate (on_off,"  - . ", "\r\n");
//---------
info=StringConcatenate(info,on_off,"\r\n");
info=StringConcatenate(info,"\r\n");
info=StringConcatenate(info, " .:    ", GeneralSignal,"\r\n" );
info=StringConcatenate(info, " .:  ", ReversSignal);
//--
Comment(info);
//-------------------------------------------------------------------------------------
   for (int i=0; i<OrdersTotal(); i++) {  
            
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {           
          if (OrderSymbol()==Symbol()) {                          
             if (OrderMagicNumber()==MagicNumber)  { 
             
                if (General==True) {         
                if (OrderType()==OP_BUY) {    //     BUY
                    if (Bid > (OrderStopLoss()+(sl*2 +spread)*Point) ) {   //   
                        //**********************************************************************************
                        if (GeneralSignal < 0) { //    
                        
                           //----    ---      4 
                           int Cnt=1;
                           while (Cnt <= 5) 
                           { 
                             RefreshRates();
                             if (OrderClose(OrderTicket(), OrderLots(), Bid ,2, Red))  break;
                             else 
                               { Print ("  Buy #", ErrorDescription( GetLastError() ), "  ", Cnt);
                               
                                 if (Cnt==5) return(0);  //  5    - 
                                 Cnt++;
                                 Sleep(15000); //  15 
                               }
                           }
                           //----     --------------------------------------------------
                           
                           Cnt=1;
                           while (Cnt <= 5) 
                           { 
                             Lots=GetSizeLot();
                             RefreshRates();
                             if (OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, Ask + sl * Point, 0,
                                 "General", MagicNumber, 0, Blue) > 0)  break;
                             else 
                               { Print ("  Sell   #", 
                                      ErrorDescription( GetLastError() ), "  ", Cnt);
                               
                                 if (Cnt==5) return(0);  //  5    - 
                                 Cnt++;
                                 Sleep(15000); //  15 
                               }   
                           }
                         }  //perceptron  
                         //***************************************************************************************  
                         if (GeneralSignal > 0) { //    
                        
                            //----    () --- 
                            Cnt=1;
                            while (Cnt <= 5) 
                            { 
                              RefreshRates();
                              if (OrderModify(OrderTicket(), OrderOpenPrice(), Bid-sl*Point,0,0,Blue)) break;
                              else 
                                { Print ("  Buy #", ErrorDescription( GetLastError() ), "  ", Cnt);
                               
                                  if (Cnt ==5) return(0);  //  5    - 
                                  Cnt++;
                                  Sleep(15000); //  15 
                                }
                            }
                         }  //perceptron 
                     }      //profit
                 }          //OP
                 
                //=============================================================================================
               
                if (OrderType()==OP_SELL) {    //     SELL

                    if (Ask < (OrderStopLoss()-(sl*2+spread)*Point)) {  //  
                    
                        //**********************************************************************************
                        if (GeneralSignal > 0) { //    
                        
                           //----    ---      4 
                           Cnt=1;
                           while (Cnt <= 5) 
                           { 
                             RefreshRates();
                             if (OrderClose(OrderTicket(), OrderLots(), Ask, 2, Red))  break;
                             else 
                               { Print ("  Sell #", ErrorDescription( GetLastError() ), "  ", Cnt);
                               
                                 if (Cnt ==5) return(0);  //  5    - 
                                 Cnt++;
                                 Sleep(15000); //  15 
                               }
                           }
                           //----     --------------------------------------------------
                           
                           Cnt=1;
                           while (Cnt <= 5) 
                           { 
                             Lots=GetSizeLot();
                             RefreshRates();
                             if (OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, Bid - sl * Point, 
                                       0,"General",  MagicNumber, 0, Blue) > 0) break;  
                             else 
                               { Print ("  Buy   #", ErrorDescription( GetLastError() ), "  ", Cnt);
                               
                                 if (Cnt==5) return(0);  //  5    - 
                                 Cnt++;
                                 Sleep(15000); //  15 
                               }   
                           }
                         }  //perceptron
                         //***************************************************************************************  
                         if (GeneralSignal < 0) { //    
                        
                            //----    () --- 
                            Cnt=1;
                            while (Cnt <= 5) 
                            { 
                              RefreshRates();
                              if (OrderModify(OrderTicket(), OrderOpenPrice(), Ask+sl*Point,0,0,Blue)) break;
                              else 
                                { Print ("  Sell #", ErrorDescription( GetLastError() ), "  ", Cnt);
                               
                                  if (Cnt ==5) return(0);  //  5    - 
                                  Cnt++;
                                  Sleep(15000); //  15 
                                }
                            }
                         }  //perceptron 
                     }      //profit  
                 }          //OP  
             // return(0); 
             } //
             } //magic
             
             //----------------------------------------------------------------------------------------
             //--------                            revers                                --------------
             //----------------------------------------------------------------------------------------
             
             if (OrderMagicNumber()==MagicRevers)  { 
                                    
                if (Revers==true) {        
                if (OrderType()==OP_BUY) {    //     BUY
                   
                    if (Bid > (OrderStopLoss()+(sl_r*2 +spread)*Point) ) {   //   
                        //**********************************************************************************
                        if (ReversSignal > 0) { //    
                        
                           //----    ---      4 
                           Cnt=1;
                           while (Cnt <= 5) 
                           { 
                             RefreshRates();
                             if (OrderClose(OrderTicket(), OrderLots(), Bid ,2, Red)) break;
                             else 
                               { Print ("  Buy #", ErrorDescription( GetLastError() ), "  ", Cnt);
                               
                                 if (Cnt ==5) return(0);  //  5    - 
                                 Cnt++;
                                 Sleep(15000); //  15 
                               }
                           }
                           //----     --------------------------------------------------
                           
                           Cnt=1;
                           while (Cnt <= 5) 
                           { 
                             Lots=GetSizeLot();
                             RefreshRates();
                             if (OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, Ask + sl_r * Point, 0,
                                 "Revers", MagicRevers, 0, Red) > 0)  break;
                             else 
                               { Print ("  Sell   #", ErrorDescription( GetLastError() ), "  ", Cnt);
                               
                                 if (Cnt==5) return(0);  //  5    - 
                                 Cnt++;
                                 Sleep(15000); //  15 
                               }   
                           }
                         }  //perceptron  
                         //***************************************************************************************  
                         if (ReversSignal < 0) { //    
                        
                            //----    () --- 
                            Cnt=1;
                            while (Cnt <= 5) 
                            { 
                              RefreshRates();
                              if (OrderModify(OrderTicket(), OrderOpenPrice(), Bid-sl_r*Point,0,0,Red)) break;
                              else 
                                { Print ("  Buy #", ErrorDescription( GetLastError() ), "  ", Cnt);
                               
                                  if (Cnt ==5) return(0);  //  5    - 
                                  Cnt++;
                                  Sleep(15000); //  15 
                                }
                            }
                         }  //perceptron 
                     }      //profit
                 }          //OP
                 
                //=============================================================================================
               
                if (OrderType()==OP_SELL) {    //     SELL

                    if (Ask < (OrderStopLoss()-(sl_r*2+spread)*Point)) {  //  
                    
                        //**********************************************************************************
                        if (ReversSignal < 0) { //    
                        
                           //----    ---      4 
                           Cnt=1;
                           while (Cnt <= 5) 
                           { 
                             RefreshRates();
                             if (OrderClose(OrderTicket(), OrderLots(), Ask, 2, Red)) break;
                             else 
                               { Print ("  Sell #", ErrorDescription( GetLastError() ), "  ", Cnt);
                               
                                 if (Cnt ==5) return(0);  //  5    - 
                                 Cnt++;
                                 Sleep(15000); //  15 
                               }
                           }
                           //----     --------------------------------------------------
                           
                           Cnt=1;
                           while (Cnt <= 5) 
                           { 
                             Lots=GetSizeLot();
                             RefreshRates();
                             if (OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, Bid - sl_r * Point, 0,
                                           "Revers",  MagicRevers, 0, Red) > 0)  break; 
                             else 
                               { Print ("  Buy   #", ErrorDescription( GetLastError() ), "  ", Cnt);
                               
                                 if (Cnt==5) return(0);  //  5    - 
                                 Cnt++;
                                 Sleep(15000); //  15 
                               }   
                           }
                         }  //perceptron
                         //***************************************************************************************  
                         if (ReversSignal > 0) { //    
                        
                            //----    () --- 
                            Cnt=1;
                            while (Cnt <= 5) 
                            { 
                              RefreshRates();
                              if (OrderModify(OrderTicket(), OrderOpenPrice(), Ask+sl_r*Point,0,0,Red)) break;
                              else 
                                { Print ("  Sell #", ErrorDescription( GetLastError() ), "  ", Cnt);
                               
                                  if (Cnt ==5) return(0);  //  5    - 
                                  Cnt++;
                                  Sleep(15000); //  15 
                                }
                            }
                         }  //perceptron 
                     }      //profit  
                 }          //OP 
           } //
          //--------------------------
          //end revers
          //--------------------------
             
          } // magic
       } //symbol
    } // select
  } //total
//=============================================================================================
if (General) {     //      "" 
if (!ExpertOrder(MagicNumber)) {
if (GeneralSignal > 0) { //    
  
  //----     --------------------------------------------------                       
  Cnt=1;
  while (Cnt <= 5) 
  { 
    Lots=GetSizeLot();
    if (OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, Bid - sl * Point, 0,
                  "General",  MagicNumber, 0, Blue) > 0)  break;    
    else 
      { Print ("  Buy #", ErrorDescription( GetLastError() ), "  ", Cnt);
                               
        if (Cnt==5) return(0);  //  5    - 
        Cnt++;
        Sleep(15000); //  15 
      }   
  }
 } 

else {    //    
  
  Cnt=1;
  while (Cnt <= 5) 
  { 
    Lots=GetSizeLot();
    if (OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, Ask + sl * Point, 0,
                  "General", MagicNumber, 0, Blue) > 0)  break;    
    else 
      { Print ("  Sell #", ErrorDescription( GetLastError() ), "  ", Cnt);
                               
        if (Cnt==5) return(0);  //  5    - 
        Cnt++;
        Sleep(15000); //  15 
      }   
  }
 } // perceptron
 }
 } // if Order
 
//===================  ===================================================================

if (Revers) {                       // "" 
if (!ExpertOrder(MagicRevers)) {
if (ReversSignal < 0) {             //   
  
  //----     --------------------------------------------------                       
  Cnt=1;
  while (Cnt <= 5) 
  { 
    Lots=GetSizeLot();
    if (OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, Bid - sl_r * Point, 0,
                  "Revers",  MagicRevers, 0, Red) > 0)  break;    
    else 
      { Print ("  Buy #", ErrorDescription( GetLastError() ), "  ", Cnt);
                               
        if (Cnt==5) return(0);  //  5    - 
        Cnt++;
        Sleep(15000); //  15 
      }   
  }
 } 

else {    //    
  
  Cnt=1;
  while (Cnt <= 5) 
  { 
    Lots=GetSizeLot();
    if (OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, Ask + sl_r * Point, 0,
                  "Revers", MagicRevers, 0, Red) > 0)  break;    
    else 
      { Print ("  Sell #", ErrorDescription( GetLastError() ), "  ", Cnt);
                               
        if (Cnt==5) return(0);  //  5    - 
        Cnt++;
        Sleep(15000); //  15 
      }   
  }
 } // perceptron
 }
 } // if Order
//=====================================================================================================

} //isNewBar 
//----
   return(0);  
  }
//+------------------------------------------------------------------+
//|  The PERCEPTRON - a perceiving and recognizing function          |
//+------------------------------------------------------------------+
double perceptron() 
  {
   double w1 = x1 - 100.0;
   double w2 = x2 - 100.0;
   double w3 = x3 - 100.0;
   double w4 = x4 - 100.0;
     double w5 = x5 - 100.0;
   
   double a1 = iWPR(Symbol(),  0,WPR_period,  P_1)+50; 
   double a2 = iWPR(Symbol(),  0,WPR_period,  P_2)+50;
   double a3 = iWPR(Symbol(),  0,WPR_period,  P_3)+50;
   double a4 = iWPR(Symbol(),  0,WPR_period,  P_4)+50;
   double a5 = iWPR(Symbol(), 0,WPR_period,  p_5)+50;
 
     
   return (w1 * a1 + w2 * a2 + w3 * a3 + w4 * a4 + w5 * a5 );
  }   
//-----------------------------------------------------------------------------------+
double perceptron_r() // 
  {
   double w1 = r1 - 100.0;
   double w2 = r2 - 100.0;
   double w3 = r3 - 100.0;
   double w4 = r4 - 100.0;
     double w5 = r5 - 100.0;

   double a1 = iWPR(Symbol(),  0,WPR_REV_period,  P_1)+50; 
   double a2 = iWPR(Symbol(),  0,WPR_REV_period,  P_2)+50;
   double a3 = iWPR(Symbol(),  0,WPR_REV_period,  P_3)+50;
   double a4 = iWPR(Symbol(),  0,WPR_REV_period,  P_4)+50;
   double a5 = iWPR(Symbol(), 0,WPR_REV_period,  p_5)+50;
 
   
   return (w1 * a1 + w2 * a2 + w3 * a3 + w4 * a4 + w5 * a5 );
  }
  
//---------------------------------------------------------------------------------+
//----      ----------------------------------+
//---------------------------------------------------------------------------------+
// false -    ;                                           |
// true  -    ;                                           |
//---------------------------------------------------------------------------------+
bool ExpertOrder (int VersionID){
//--
bool result=false;

int  _OrdersTotal=OrdersTotal();
//--
if (_OrdersTotal>0) {
    for (int n=0; n<_OrdersTotal; n++) { 
   
      if (OrderSelect(n, SELECT_BY_POS, MODE_TRADES)) {
        if (OrderMagicNumber()==VersionID) 
           { result=true;  break; }       //   
        else   
           { result=false; } 
       }      
     }        
   }
else { result=false; }  
//---------------------        
return(result);
}
//---------------------------------------------------------------------------------+
 